git-rebase--interactive.shon commit send-email: signedoffcc -> signedoffbycc, but handle both (ddc3d4f)
   1#!/bin/sh
   2#
   3# Copyright (c) 2006 Johannes E. Schindelin
   4
   5# SHORT DESCRIPTION
   6#
   7# This script makes it easy to fix up commits in the middle of a series,
   8# and rearrange commits.
   9#
  10# The original idea comes from Eric W. Biederman, in
  11# http://article.gmane.org/gmane.comp.version-control.git/22407
  12
  13OPTIONS_KEEPDASHDASH=
  14OPTIONS_SPEC="\
  15git-rebase [-i] [options] [--] <upstream> [<branch>]
  16git-rebase [-i] (--continue | --abort | --skip)
  17--
  18 Available options are
  19v,verbose          display a diffstat of what changed upstream
  20onto=              rebase onto given branch instead of upstream
  21p,preserve-merges  try to recreate merges instead of ignoring them
  22s,strategy=        use the given merge strategy
  23m,merge            always used (no-op)
  24i,interactive      always used (no-op)
  25 Actions:
  26continue           continue rebasing process
  27abort              abort rebasing process and restore original branch
  28skip               skip current patch and continue rebasing process
  29"
  30
  31. git-sh-setup
  32require_work_tree
  33
  34DOTEST="$GIT_DIR/rebase-merge"
  35TODO="$DOTEST"/git-rebase-todo
  36DONE="$DOTEST"/done
  37MSG="$DOTEST"/message
  38SQUASH_MSG="$DOTEST"/message-squash
  39REWRITTEN="$DOTEST"/rewritten
  40PRESERVE_MERGES=
  41STRATEGY=
  42ONTO=
  43VERBOSE=
  44
  45GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
  46mark the corrected paths with 'git add <paths>', and
  47run 'git rebase --continue'"
  48export GIT_CHERRY_PICK_HELP
  49
  50warn () {
  51        echo "$*" >&2
  52}
  53
  54output () {
  55        case "$VERBOSE" in
  56        '')
  57                output=$("$@" 2>&1 )
  58                status=$?
  59                test $status != 0 && printf "%s\n" "$output"
  60                return $status
  61                ;;
  62        *)
  63                "$@"
  64                ;;
  65        esac
  66}
  67
  68require_clean_work_tree () {
  69        # test if working tree is dirty
  70        git rev-parse --verify HEAD > /dev/null &&
  71        git update-index --ignore-submodules --refresh &&
  72        git diff-files --quiet --ignore-submodules &&
  73        git diff-index --cached --quiet HEAD --ignore-submodules -- ||
  74        die "Working tree is dirty"
  75}
  76
  77ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
  78
  79comment_for_reflog () {
  80        case "$ORIG_REFLOG_ACTION" in
  81        ''|rebase*)
  82                GIT_REFLOG_ACTION="rebase -i ($1)"
  83                export GIT_REFLOG_ACTION
  84                ;;
  85        esac
  86}
  87
  88last_count=
  89mark_action_done () {
  90        sed -e 1q < "$TODO" >> "$DONE"
  91        sed -e 1d < "$TODO" >> "$TODO".new
  92        mv -f "$TODO".new "$TODO"
  93        count=$(grep -c '^[^#]' < "$DONE")
  94        total=$(($count+$(grep -c '^[^#]' < "$TODO")))
  95        if test "$last_count" != "$count"
  96        then
  97                last_count=$count
  98                printf "Rebasing (%d/%d)\r" $count $total
  99                test -z "$VERBOSE" || echo
 100        fi
 101}
 102
 103make_patch () {
 104        parent_sha1=$(git rev-parse --verify "$1"^) ||
 105                die "Cannot get patch for $1^"
 106        git diff-tree -p "$parent_sha1".."$1" > "$DOTEST"/patch
 107        test -f "$DOTEST"/message ||
 108                git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
 109        test -f "$DOTEST"/author-script ||
 110                get_author_ident_from_commit "$1" > "$DOTEST"/author-script
 111}
 112
 113die_with_patch () {
 114        make_patch "$1"
 115        git rerere
 116        die "$2"
 117}
 118
 119die_abort () {
 120        rm -rf "$DOTEST"
 121        die "$1"
 122}
 123
 124has_action () {
 125        grep '^[^#]' "$1" >/dev/null
 126}
 127
 128pick_one () {
 129        no_ff=
 130        case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
 131        output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
 132        test -d "$REWRITTEN" &&
 133                pick_one_preserving_merges "$@" && return
 134        parent_sha1=$(git rev-parse --verify $sha1^) ||
 135                die "Could not get the parent of $sha1"
 136        current_sha1=$(git rev-parse --verify HEAD)
 137        if test "$no_ff$current_sha1" = "$parent_sha1"; then
 138                output git reset --hard $sha1
 139                test "a$1" = a-n && output git reset --soft $current_sha1
 140                sha1=$(git rev-parse --short $sha1)
 141                output warn Fast forward to $sha1
 142        else
 143                output git cherry-pick "$@"
 144        fi
 145}
 146
 147pick_one_preserving_merges () {
 148        fast_forward=t
 149        case "$1" in
 150        -n)
 151                fast_forward=f
 152                sha1=$2
 153                ;;
 154        *)
 155                sha1=$1
 156                ;;
 157        esac
 158        sha1=$(git rev-parse $sha1)
 159
 160        if test -f "$DOTEST"/current-commit
 161        then
 162                current_commit=$(cat "$DOTEST"/current-commit) &&
 163                git rev-parse HEAD > "$REWRITTEN"/$current_commit &&
 164                rm "$DOTEST"/current-commit ||
 165                die "Cannot write current commit's replacement sha1"
 166        fi
 167
 168        echo $sha1 > "$DOTEST"/current-commit
 169
 170        # rewrite parents; if none were rewritten, we can fast-forward.
 171        new_parents=
 172        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -f2-)
 173        do
 174                if test -f "$REWRITTEN"/$p
 175                then
 176                        new_p=$(cat "$REWRITTEN"/$p)
 177                        test $p != $new_p && fast_forward=f
 178                        case "$new_parents" in
 179                        *$new_p*)
 180                                ;; # do nothing; that parent is already there
 181                        *)
 182                                new_parents="$new_parents $new_p"
 183                                ;;
 184                        esac
 185                else
 186                        new_parents="$new_parents $p"
 187                fi
 188        done
 189        case $fast_forward in
 190        t)
 191                output warn "Fast forward to $sha1"
 192                output git reset --hard $sha1 ||
 193                        die "Cannot fast forward to $sha1"
 194                ;;
 195        f)
 196                test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
 197
 198                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 199                # detach HEAD to current parent
 200                output git checkout $first_parent 2> /dev/null ||
 201                        die "Cannot move HEAD to $first_parent"
 202
 203                case "$new_parents" in
 204                ' '*' '*)
 205                        # redo merge
 206                        author_script=$(get_author_ident_from_commit $sha1)
 207                        eval "$author_script"
 208                        msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
 209                        # No point in merging the first parent, that's HEAD
 210                        new_parents=${new_parents# $first_parent}
 211                        if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
 212                                GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
 213                                GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
 214                                output git merge $STRATEGY -m "$msg" \
 215                                        $new_parents
 216                        then
 217                                git rerere
 218                                printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
 219                                die Error redoing merge $sha1
 220                        fi
 221                        ;;
 222                *)
 223                        output git cherry-pick "$@" ||
 224                                die_with_patch $sha1 "Could not pick $sha1"
 225                        ;;
 226                esac
 227                ;;
 228        esac
 229}
 230
 231nth_string () {
 232        case "$1" in
 233        *1[0-9]|*[04-9]) echo "$1"th;;
 234        *1) echo "$1"st;;
 235        *2) echo "$1"nd;;
 236        *3) echo "$1"rd;;
 237        esac
 238}
 239
 240make_squash_message () {
 241        if test -f "$SQUASH_MSG"; then
 242                COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
 243                        < "$SQUASH_MSG" | sed -ne '$p')+1))
 244                echo "# This is a combination of $COUNT commits."
 245                sed -e 1d -e '2,/^./{
 246                        /^$/d
 247                }' <"$SQUASH_MSG"
 248        else
 249                COUNT=2
 250                echo "# This is a combination of two commits."
 251                echo "# The first commit's message is:"
 252                echo
 253                git cat-file commit HEAD | sed -e '1,/^$/d'
 254        fi
 255        echo
 256        echo "# This is the $(nth_string $COUNT) commit message:"
 257        echo
 258        git cat-file commit $1 | sed -e '1,/^$/d'
 259}
 260
 261peek_next_command () {
 262        sed -n "1s/ .*$//p" < "$TODO"
 263}
 264
 265do_next () {
 266        rm -f "$DOTEST"/message "$DOTEST"/author-script \
 267                "$DOTEST"/amend || exit
 268        read command sha1 rest < "$TODO"
 269        case "$command" in
 270        '#'*|'')
 271                mark_action_done
 272                ;;
 273        pick|p)
 274                comment_for_reflog pick
 275
 276                mark_action_done
 277                pick_one $sha1 ||
 278                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 279                ;;
 280        edit|e)
 281                comment_for_reflog edit
 282
 283                mark_action_done
 284                pick_one $sha1 ||
 285                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 286                make_patch $sha1
 287                git rev-parse --verify HEAD > "$DOTEST"/amend
 288                warn "Stopped at $sha1... $rest"
 289                warn "You can amend the commit now, with"
 290                warn
 291                warn "  git commit --amend"
 292                warn
 293                warn "Once you are satisfied with your changes, run"
 294                warn
 295                warn "  git rebase --continue"
 296                warn
 297                exit 0
 298                ;;
 299        squash|s)
 300                comment_for_reflog squash
 301
 302                has_action "$DONE" ||
 303                        die "Cannot 'squash' without a previous commit"
 304
 305                mark_action_done
 306                make_squash_message $sha1 > "$MSG"
 307                case "$(peek_next_command)" in
 308                squash|s)
 309                        EDIT_COMMIT=
 310                        USE_OUTPUT=output
 311                        cp "$MSG" "$SQUASH_MSG"
 312                        ;;
 313                *)
 314                        EDIT_COMMIT=-e
 315                        USE_OUTPUT=
 316                        rm -f "$SQUASH_MSG" || exit
 317                        ;;
 318                esac
 319
 320                failed=f
 321                author_script=$(get_author_ident_from_commit HEAD)
 322                output git reset --soft HEAD^
 323                pick_one -n $sha1 || failed=t
 324                echo "$author_script" > "$DOTEST"/author-script
 325                if test $failed = f
 326                then
 327                        # This is like --amend, but with a different message
 328                        eval "$author_script"
 329                        GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
 330                        GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
 331                        GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
 332                        $USE_OUTPUT git commit --no-verify -F "$MSG" $EDIT_COMMIT || failed=t
 333                fi
 334                if test $failed = t
 335                then
 336                        cp "$MSG" "$GIT_DIR"/MERGE_MSG
 337                        warn
 338                        warn "Could not apply $sha1... $rest"
 339                        die_with_patch $sha1 ""
 340                fi
 341                ;;
 342        *)
 343                warn "Unknown command: $command $sha1 $rest"
 344                die_with_patch $sha1 "Please fix this in the file $TODO."
 345                ;;
 346        esac
 347        test -s "$TODO" && return
 348
 349        comment_for_reflog finish &&
 350        HEADNAME=$(cat "$DOTEST"/head-name) &&
 351        OLDHEAD=$(cat "$DOTEST"/head) &&
 352        SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
 353        if test -d "$REWRITTEN"
 354        then
 355                test -f "$DOTEST"/current-commit &&
 356                        current_commit=$(cat "$DOTEST"/current-commit) &&
 357                        git rev-parse HEAD > "$REWRITTEN"/$current_commit
 358                if test -f "$REWRITTEN"/$OLDHEAD
 359                then
 360                        NEWHEAD=$(cat "$REWRITTEN"/$OLDHEAD)
 361                else
 362                        NEWHEAD=$OLDHEAD
 363                fi
 364        else
 365                NEWHEAD=$(git rev-parse HEAD)
 366        fi &&
 367        case $HEADNAME in
 368        refs/*)
 369                message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO)" &&
 370                git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
 371                git symbolic-ref HEAD $HEADNAME
 372                ;;
 373        esac && {
 374                test ! -f "$DOTEST"/verbose ||
 375                        git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
 376        } &&
 377        rm -rf "$DOTEST" &&
 378        git gc --auto &&
 379        warn "Successfully rebased and updated $HEADNAME."
 380
 381        exit
 382}
 383
 384do_rest () {
 385        while :
 386        do
 387                do_next
 388        done
 389}
 390
 391# check if no other options are set
 392is_standalone () {
 393        test $# -eq 2 -a "$2" = '--' &&
 394        test -z "$ONTO" &&
 395        test -z "$PRESERVE_MERGES" &&
 396        test -z "$STRATEGY" &&
 397        test -z "$VERBOSE"
 398}
 399
 400get_saved_options () {
 401        test -d "$REWRITTEN" && PRESERVE_MERGES=t
 402        test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
 403        test -f "$DOTEST"/verbose && VERBOSE=t
 404}
 405
 406while test $# != 0
 407do
 408        case "$1" in
 409        --continue)
 410                is_standalone "$@" || usage
 411                get_saved_options
 412                comment_for_reflog continue
 413
 414                test -d "$DOTEST" || die "No interactive rebase running"
 415
 416                # Sanity check
 417                git rev-parse --verify HEAD >/dev/null ||
 418                        die "Cannot read HEAD"
 419                git update-index --ignore-submodules --refresh &&
 420                        git diff-files --quiet --ignore-submodules ||
 421                        die "Working tree is dirty"
 422
 423                # do we have anything to commit?
 424                if git diff-index --cached --quiet --ignore-submodules HEAD --
 425                then
 426                        : Nothing to commit -- skip this
 427                else
 428                        . "$DOTEST"/author-script ||
 429                                die "Cannot find the author identity"
 430                        amend=
 431                        if test -f "$DOTEST"/amend
 432                        then
 433                                amend=$(git rev-parse --verify HEAD)
 434                                test "$amend" = $(cat "$DOTEST"/amend) ||
 435                                die "\
 436You have uncommitted changes in your working tree. Please, commit them
 437first and then run 'git rebase --continue' again."
 438                                git reset --soft HEAD^ ||
 439                                die "Cannot rewind the HEAD"
 440                        fi
 441                        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
 442                        git commit --no-verify -F "$DOTEST"/message -e || {
 443                                test -n "$amend" && git reset --soft $amend
 444                                die "Could not commit staged changes."
 445                        }
 446                fi
 447
 448                require_clean_work_tree
 449                do_rest
 450                ;;
 451        --abort)
 452                is_standalone "$@" || usage
 453                get_saved_options
 454                comment_for_reflog abort
 455
 456                git rerere clear
 457                test -d "$DOTEST" || die "No interactive rebase running"
 458
 459                HEADNAME=$(cat "$DOTEST"/head-name)
 460                HEAD=$(cat "$DOTEST"/head)
 461                case $HEADNAME in
 462                refs/*)
 463                        git symbolic-ref HEAD $HEADNAME
 464                        ;;
 465                esac &&
 466                output git reset --hard $HEAD &&
 467                rm -rf "$DOTEST"
 468                exit
 469                ;;
 470        --skip)
 471                is_standalone "$@" || usage
 472                get_saved_options
 473                comment_for_reflog skip
 474
 475                git rerere clear
 476                test -d "$DOTEST" || die "No interactive rebase running"
 477
 478                output git reset --hard && do_rest
 479                ;;
 480        -s)
 481                case "$#,$1" in
 482                *,*=*)
 483                        STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
 484                1,*)
 485                        usage ;;
 486                *)
 487                        STRATEGY="-s $2"
 488                        shift ;;
 489                esac
 490                ;;
 491        -m)
 492                # we use merge anyway
 493                ;;
 494        -v)
 495                VERBOSE=t
 496                ;;
 497        -p)
 498                PRESERVE_MERGES=t
 499                ;;
 500        -i)
 501                # yeah, we know
 502                ;;
 503        --onto)
 504                shift
 505                ONTO=$(git rev-parse --verify "$1") ||
 506                        die "Does not point to a valid commit: $1"
 507                ;;
 508        --)
 509                shift
 510                test $# -eq 1 -o $# -eq 2 || usage
 511                test -d "$DOTEST" &&
 512                        die "Interactive rebase already started"
 513
 514                git var GIT_COMMITTER_IDENT >/dev/null ||
 515                        die "You need to set your committer info first"
 516
 517                comment_for_reflog start
 518
 519                require_clean_work_tree
 520
 521                UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
 522                test -z "$ONTO" && ONTO=$UPSTREAM
 523
 524                if test ! -z "$2"
 525                then
 526                        output git show-ref --verify --quiet "refs/heads/$2" ||
 527                                die "Invalid branchname: $2"
 528                        output git checkout "$2" ||
 529                                die "Could not checkout $2"
 530                fi
 531
 532                HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
 533                mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
 534
 535                : > "$DOTEST"/interactive || die "Could not mark as interactive"
 536                git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
 537                        echo "detached HEAD" > "$DOTEST"/head-name
 538
 539                echo $HEAD > "$DOTEST"/head
 540                echo $UPSTREAM > "$DOTEST"/upstream
 541                echo $ONTO > "$DOTEST"/onto
 542                test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
 543                test t = "$VERBOSE" && : > "$DOTEST"/verbose
 544                if test t = "$PRESERVE_MERGES"
 545                then
 546                        # $REWRITTEN contains files for each commit that is
 547                        # reachable by at least one merge base of $HEAD and
 548                        # $UPSTREAM. They are not necessarily rewritten, but
 549                        # their children might be.
 550                        # This ensures that commits on merged, but otherwise
 551                        # unrelated side branches are left alone. (Think "X"
 552                        # in the man page's example.)
 553                        mkdir "$REWRITTEN" &&
 554                        for c in $(git merge-base --all $HEAD $UPSTREAM)
 555                        do
 556                                echo $ONTO > "$REWRITTEN"/$c ||
 557                                        die "Could not init rewritten commits"
 558                        done
 559                        MERGES_OPTION=
 560                else
 561                        MERGES_OPTION=--no-merges
 562                fi
 563
 564                SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
 565                SHORTHEAD=$(git rev-parse --short $HEAD)
 566                SHORTONTO=$(git rev-parse --short $ONTO)
 567                git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
 568                        --abbrev=7 --reverse --left-right --cherry-pick \
 569                        $UPSTREAM...$HEAD | \
 570                        sed -n "s/^>/pick /p" > "$TODO"
 571                cat >> "$TODO" << EOF
 572
 573# Rebase $SHORTUPSTREAM..$SHORTHEAD onto $SHORTONTO
 574#
 575# Commands:
 576#  p, pick = use commit
 577#  e, edit = use commit, but stop for amending
 578#  s, squash = use commit, but meld into previous commit
 579#
 580# If you remove a line here THAT COMMIT WILL BE LOST.
 581# However, if you remove everything, the rebase will be aborted.
 582#
 583EOF
 584
 585                has_action "$TODO" ||
 586                        die_abort "Nothing to do"
 587
 588                cp "$TODO" "$TODO".backup
 589                git_editor "$TODO" ||
 590                        die "Could not execute editor"
 591
 592                has_action "$TODO" ||
 593                        die_abort "Nothing to do"
 594
 595                git update-ref ORIG_HEAD $HEAD
 596                output git checkout $ONTO && do_rest
 597                ;;
 598        esac
 599        shift
 600done